/************************************************************************************
coordinatetransformationirs
Copyright (c) 2010, International Rescue System Institute
All rights reserved.

Contact us if you use this software for sell.
If you use this software not for sell, you can use this software under BSD license.
See the files LICENSE.TXT and LICENSE-BSD.TXT for more details.                     
************************************************************************************/

//***************************************************************************************//
//* TestOutput.cpp							     2009.12.17 *//
//*											*//
//* Test Output RTMプログラム [Ver.1.0.0]						*//
//***************************************************************************************//


// -*- C++ -*-
/*!
 * @file  TestOutput.cpp
 * @brief Test Output for Coordinate Transformation Module
 * $Date$
 *
 * $Id$
 */

#include "TestOutput.h"

// Module specification
// <rtc-template block="module_spec">
static const char* testoutput_spec[] =
  {
    "implementation_id", "TestOutput",
    "type_name",         "TestOutput",
    "description",       "Test Output for Coordinate Transformation Module",
    "version",           "1.0.0",
    "vendor",            "IRS",
    "category",          "Position",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables

    ""
  };
// </rtc-template>

TestOutput::TestOutput(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_InJgd2000PositionIn("InJgd2000Position", m_InJgd2000Position),
    m_In19PositionIn("In19Position", m_In19Position),
    m_InRobotPositionIn("InRobotPosition", m_InRobotPosition),
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("InJgd2000Position", m_InJgd2000PositionIn);
  registerInPort("In19Position", m_In19PositionIn);
  registerInPort("InRobotPosition", m_InRobotPositionIn);
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

TestOutput::~TestOutput()
{
}

RTC::ReturnCode_t TestOutput::onInitialize()
{
	// <rtc-template block="bind_config">
	// Bind variables and configuration variable
  
	// </rtc-template>


	return RTC::RTC_OK;										// 戻り値 [正常終了]

}

/*
RTC::ReturnCode_t TestOutput::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TestOutput::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TestOutput::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

RTC::ReturnCode_t TestOutput::onActivated(RTC::UniqueId ec_id)
{

	return RTC::RTC_OK;										// 戻り値 [正常終了]

}

RTC::ReturnCode_t TestOutput::onDeactivated(RTC::UniqueId ec_id)
{


	//-- [終了処理] -------------------------------------------------------------------------//

	fflush(stdout);											// バッファフラッシュ [printf表示用]
	printf("\x1b[15B");										// エスケープシーケンス

	//---------------------------------------------------------------------------------------//


	return RTC::RTC_OK;										// 戻り値 [正常終了]

}

RTC::ReturnCode_t TestOutput::onExecute(RTC::UniqueId ec_id)
{


	//-- [データ更新] -----------------------------------------------------------------------//

	if((m_InJgd2000PositionIn.isNew()) || (m_In19PositionIn.isNew()) ||
		(m_InRobotPositionIn.isNew())){								// 更新チェック

		m_InJgd2000PositionIn.read();								// データ読み込み
		m_In19PositionIn.read();								// データ読み込み
		m_InRobotPositionIn.read();								// データ読み込み


		//-- [InJgd2000Position表示] ----------------------------------------------------//

		printf("\n[Jgd2000Position  ]\n");							// メッセージ表示 [Jgd2000Position]
		printf("                                                  \r");				// 初期化 [空白]
		printf("-[Timestamp       ] %lf\n", (double)m_InJgd2000Position.tm.sec
			+ (double)m_InJgd2000Position.tm.nsec / 1000000000.0);				// メッセージ表示 [Timestamp]
		printf("                                                  \r");				// 初期化 [空白]
		printf("-[Latitude        ] %lf\n", m_InJgd2000Position.latitude);			// メッセージ表示 [Latitude]
		printf("                                                  \r");				// 初期化 [空白]
		printf("-[Longitude       ] %lf\n", m_InJgd2000Position.longitude);			// メッセージ表示 [Longitude]

		//-------------------------------------------------------------------------------//


		//-- [In19Position表示] ---------------------------------------------------------//

		printf("\n[19Position       ]\n");							// メッセージ表示 [19Position]
		printf("                                                  \r");				// 初期化 [空白]
		printf("-[Timestamp       ] %lf\n", (double)m_In19Position.tm.sec
			+ (double)m_In19Position.tm.nsec / 1000000000.0);				// メッセージ表示 [Timestamp]
		printf("                                                  \r");				// 初期化 [空白]
		printf("-[X               ] %lf\n", m_In19Position.x);					// メッセージ表示 [X]
		printf("                                                  \r");				// 初期化 [空白]
		printf("-[Y               ] %lf\n", m_In19Position.y);					// メッセージ表示 [Y]

		//-------------------------------------------------------------------------------//


		//-- [InRobotPosition表示] ------------------------------------------------------//

		printf("\n[RobotPosition    ]\n");							// メッセージ表示 [RobotPosition]
		printf("                                                  \r");				// 初期化 [空白]
		printf("-[Timestamp       ] %lf\n", (double)m_InRobotPosition.tm.sec
			+ (double)m_InRobotPosition.tm.nsec / 1000000000.0);				// メッセージ表示 [Timestamp]
		printf("                                                  \r");				// 初期化 [空白]
		printf("-[X               ] %lf\n", m_InRobotPosition.x);				// メッセージ表示 [X]
		printf("                                                  \r");				// 初期化 [空白]
		printf("-[Y               ] %lf\n", m_InRobotPosition.y);				// メッセージ表示 [Y]

		//-------------------------------------------------------------------------------//


		//-- [復帰処理] -----------------------------------------------------------------//

		fflush(stdout);										// バッファフラッシュ [printf表示用]
		printf("\x1b[15A");									// エスケープシーケンス

		//-------------------------------------------------------------------------------//


	}

	//---------------------------------------------------------------------------------------//


	return RTC::RTC_OK;										// 戻り値 [正常終了]

}

/*
RTC::ReturnCode_t TestOutput::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TestOutput::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TestOutput::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TestOutput::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TestOutput::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void TestOutputInit(RTC::Manager* manager)
  {
    RTC::Properties profile(testoutput_spec);
    manager->registerFactory(profile,
                             RTC::Create<TestOutput>,
                             RTC::Delete<TestOutput>);
  }
  
};


